<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <div class="filters-wrapper-header">
        <i class="icon-filters icon-filter"></i><span>Filters</span>
    </div>
    <div class="filters-wrapper-body">
        <div class="filter-column modal-box">
            <div class="modal-input col">
                <label for="name-search">Name contains</label>
                <input type="text" name="name-search" id="name-search" v-model="nameFilter" />
            </div>
        </div>
        <div class="filter-column modal-box">
            <div class="modal-input col">
                <label for="description-search">Description contains</label>
                <input type="text" name="description-search" id="description-search" v-model="descriptionFilter" />
            </div>
        </div>
        <div class="filter-column modal-box">
            <div class="modal-input col">
                <label for="short-description-search">Short description contains</label>
                <input type="text" name="short-description-search" id="short-description-search" v-model="shortDescriptionFilter" />
            </div>
        </div>
        <div v-for="(column, index) in filteredColumns" :key="column?.id" class="filter-column modal-box">
            <BoxSearch :ref="setBoxSearchRef(index)" :searchTile="column?.label" :domains="getPlatformsForColumn(column, index)"  />
        </div>
    </div>
    <div class="filters-wrapper-footer">
        <button class="submit-filters" @click="applyFilters">Apply Filters</button>
        <div class="footer-buttons">
            <div class="button-icon" @click="clearFilters"><i class="icon-delete"></i></div>
            <div class="button-icon" @click="$emit('toggleFilter')">
                <i class="icon-close"></i></div>
        </div>
    </div>
</template>

<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import BoxSearch from '../BoxSearch.vue';
import type { platformArray } from '~/interfaces/types';
import { defineEmits, ref, type Ref } from 'vue';

// Define a type for the BoxSearch component instance
type BoxSearchRef = InstanceType<typeof BoxSearch>;

const emit = defineEmits(['applyFilters', 'toggleFilter']);

const props = defineProps<{ data: DataTableI, filterOpen: Boolean }>()

// Computed property to filter the columns
const filteredColumns = computed(() => {
  return props.data.columns.filter(column => column.searchable && column.searchableType === 'list');
});

// Filters
const nameFilter = ref('');
const descriptionFilter = ref('');
const shortDescriptionFilter = ref('');
const boxSearchRefs = ref<(InstanceType<typeof BoxSearch> | null)[]>([]); // Array to store refs for BoxSearch components

// Emit the filters to the parent when Apply Filters is clicked
const applyFilters = () => {
  // Emit the new filter values to the parent
  emit('applyFilters', {
    name: nameFilter.value,
    description: descriptionFilter.value,
    shortDescription: shortDescriptionFilter.value,
  });

  // Emit event to close the filter area after applying filters
  emit('toggleFilter');
};

// Function to dynamically assign refs to BoxSearch components
function setBoxSearchRef(index: number) {
  return (el: InstanceType<typeof BoxSearch> | null) => {
    boxSearchRefs.value[index] = el;
  };
}

// Method to clear filters
const clearFilters = () => {
    nameFilter.value = '';
    descriptionFilter.value = '';
    shortDescriptionFilter.value = '';

     // Clear selection in BoxSearch components
     boxSearchRefs.value.forEach(ref => {
        if (ref && typeof ref.clearSelection === 'function') {
            ref.clearSelection(); // Call the clearSelection method
        }
    });
    
    // Emit event to the parent component to notify clearing of filters
    emit('applyFilters', {
        name: '',
        description: '',
        shortDescription: '',
    });
};


const data0 = ref([
  { id: 1, name: 'AWS S3', value: 's3' },
  { id: 2, name: 'Looker', value: 'looker' },
  { id: 3, name: 'Big Query', value: 'bigquery' },
  { id: 4, name: 'Looker', value: 'looker2' },
  { id: 5, name: 'Big Query', value: 'bigquery2' },
  { id: 6, name: 'AWS S3', value: 's3-1' },
  { id: 7, name: 'AWS S3', value: 's3-2' },
  { id: 8, name: 'AWS S3', value: 's3-3' },
  { id: 9, name: 'Big Query', value: 'bigquery3' }
]);

const data1 = ref([
  { id: 1, name: 'Domain 1', value: 'domain1' },
  { id: 2, name: 'Domain 2', value: 'domain2' },
  { id: 3, name: 'Domain 3', value: 'domain3' },
  { id: 4, name: 'Domain 4', value: 'domain4' },
  { id: 5, name: 'Domain 5', value: 'domain5' },
  { id: 6, name: 'Domain 6', value: 'domain6' }
]);

// Method to determine which array to use
const getPlatformsForColumn = (column: any, index: number) => {
  // You can use logic here to determine which array to return.
  // For instance, alternate between data0 and data1 based on index
  return index % 2 === 0 ? data0.value : data1.value;
};
</script>